-- To see how bit repr of (Bool,Maybe Bool) would be like

module BitsizeTest where

import Clash.Prelude
import Clash.Explicit.Testbench

nxt :: (Bool, Maybe Bool) -> (Bool, Maybe Bool)
nxt (a, b) = case (a, b) of
  (False, Nothing) -> (False, Just False)
  (False, Just False) -> (False, Just True)
  (False, Just True) -> (True, Nothing)
  (True, Nothing) -> (True, Just False)
  (True, Just False) -> (True, Just True)
  (True, Just True) -> (False, Nothing)

tf :: (Bool, Maybe Bool) -> Bool -> ((Bool, Maybe Bool), Bool)
tf s inp = (nxt s, fst $ nxt s)

mon
  :: SystemClockResetEnable
  => Signal System Bool
  -> Signal System Bool
mon = mealy tf (False, Nothing)

topEntity
  :: Clock System
  -> Reset System
  -> Enable System
  -> Signal System Bool
  -> Signal System Bool
topEntity = exposeClockResetEnable mon


-- testBench :: Signal System Bool
-- testBench = done
--   where
--     testInput      = stimuliGenerator clk rst
--       $(listToVecTH [_) :: Inp,
--                      _),
--                      _])
--     expectedOutput = outputVerifier' clk rst
--       $(listToVecTH [False,
--                      False,
--                      False])
--     done           = expectedOutput (topEntity clk rst (enableGen) testInput)
  --     clk            = tbSystemClockGen (not < done)
--     rst            = systemResetGen
