(*
https://www.smlnj.org/doc/smlnj-lib/Util/str-ParserComb.html
https://github.com/smlnj/smlnj/blob/main/smlnj-lib/Util/parser-comb.sml
*)

datatype 'a re
  = Null
  | Eps
  | Chr of 'a
  | Cat of 'a re * 'a re
  | Alt of 'a re * 'a re
  | Star of 'a re

fun op /\ (x, y) = Cat (x, y)
fun op \/ (x, y) = Alt (x, y)
infixr 8 /\
infixr 9 \/

(* type 'a result = ('a * string) option *)
(* type 'a parser = string -> 'a result *)

(* fun chr c [] = NONE *)
(*   | chr c (x::xs) = SOME (x, xs) *)
(* chr c : char list -> char result *)
fun chr c =
    fn [] => NONE
     | (x::xs) => SOME (x, xs)
(* chr #"a" (explode "abcd");; *)
(* val it = SOME (#"a",[#"b",#"c",#"d"]) : (char * char list) option *)



(* chr: char -> char parser *)
(* fun chr (c:char) : char parser = *)
(*   let *)
(*     val pf: string -> char result = *)
(*      fn [] => NONE *)
(*       | x::xs => SOME (x, xs) *)
(*   in {runP=pf} *)
(*   end *)

(* (#runP (chr #"a")) "abc" *)

(* fun chr (c:char) = *)
(*   let *)
(*     val (pf:string->char result) = *)
(*      fn [] => NONE *)
(*       | x::(xs:string) => SOME (x, xs) *)
(*   in {runP=pf} *)
(*   end *)
